function [X,Y,D,U] = gettouch (c, trial, cue, mode)

%@CORTEX/PRIVATE/GETTOUCH  touchscreen data retrieval core function
%
%   For internal use only. Use TOUCH and TRIALTOUCH instead
%
%Last modified: 8 Feb 06

% last uncommented changes: 28 Oct 04
% 08 Feb 06: bug fixed in errifinvalidtrial
%            some checks added

if c.tch.rate==0, error (['object ' c.name ' does not contain touchscreen data']); end
errifinvalidtrial (c, trial);
if cue
   fi = find (c.codes(trial,:) == cue);
   if isempty (fi)
      offset = NaN;
   else
      offset = c.times (trial, fi);
   end
else
   offset = 0;
end
   
%all other argument checking done by caller functions
range = c.tch.ptr (trial) : c.tch.ptr (trial+1)-1;
if range==0
    X=[]; Y=[]; D=[]; U=[];
    return
end
tX = c.tch.X (range);
tY = c.tch.Y (range);
T = double (c.tch.T (range)) - offset;

if mode
   changes = find (diff(T) > c.tch.rate/2*3);
   did = [1; changes+1];
   uid = [changes; length(T)];
   D = T(did);
   U = T(uid);
   switch mode
      case 1 % down
         X = tX(did);
         Y = tY(did);
      case 2 % up
         X = tX(uid);
         Y = tY(uid);
      case 3 % mean
         for st = 1:length(D)
            subr = did(st):uid(st);
            X(st,1) = mean(tX(subr));
            Y(st,1) = mean(tY(subr));
         end
   end
else
   X = tX;
   Y = tY;
   D = T;
   U = T;
end