function h = barerr (b, L, U, varargin)

% BARERR  adds error bars to existing barseries objects
%
% Last modified: 31 Jan 06

if nargin < 2, error ('too few arguments'); end
if nargin == 2, U=L; end
            
% b is a vector of handles to barseries objects
noho = ~ishold; hold on

[xc yc] = midofbars (b);
xc = vector (xc);
yc = vector (yc);
Ler = vector (L);
Uer = vector (U);
h  = errorbar (xc, yc, Ler, Uer, 'linestyle', 'none', 'color', 'black', varargin{:});
if noho, hold off; end