function do = catscat (varargin)

%CATSCAT category scatter plot
%   CATSCAT(DATA)   plots data points in the DATA cell array. Each cell
%   must contain an array of Y values that will be individually plotted in
%   a column. Data from different cells are plotted at different positions
%   along the X axis.
%
%   CATSCAT(X, DATA) plots Y data at the positions in X.
%
%   CATSCAT(..., EXTRA)  all 'PropertyName', PropertyValue pairs permitted
%   by the function plot can be added here
%
%   DO=CATSCAT(...)  returns the handles to the plotted objects
%
%Last modified: 01 Feb 06

data = varargin{1};
dl = prod(size(data));
if iscell(data)
    x = 1:dl;
    extrarg1 = 2;
elseif isnumeric (data)
    % then this must be X. check length
    x = data;
    data = varargin{2};
    if ~iscell(data), error ('invalid argument'); end
    if dl ~= prod(size(x)), error ('X and DATA must have equal length'); end
    extrarg1 = 3;
end

noho = ~ishold;
if length(varargin) >= extrarg1
    extrargs = varargin(extrarg1:end);
else
    extrargs = {'ko'};
end
for j=1:dl
    ld = length (data{j});
    pas = repmat (x(j), ld, 1);
    do(j) = plot (pas, data{j}, extrargs{:});
    hold on
end

if noho, hold off; end